PSTAT(8)

NAME
pstat, swapinfo - display system data structures

SYNOPSIS
pstat [-Tfknstv] [-M core] [-N system]

swapinfo [-k]

DESCRIPTION
Pstat displays open file entry, swap space utilization, terminal state, and vnode data structures. If corefile is given, the information is sought there, otherwise in /dev/kmem. The required namelist is taken from /kernel unless system is specified.

If invoked as swapinfo the -s option is implied, and only the -k option is legal.

Options are

-n  Print devices out by major/minor instead of name.

-k  Print sizes in kilobytes, regardless of the setting of the BLOCKSIZE environment variable.

-T  Prints the number of used and free slots in the several system tables and is useful for checking to see how large system tables have become if the system is under heavy load.

-f  Print the open file table with these headings:

    LOC The core location of this table entry.

    TYPE
        The type of object the file table entry points to.

    FLG Miscellaneous state variables encoded thus:

        R   open for reading

        W   open for writing

        A   open for appending

        S   shared lock present

        X   exclusive lock present

        I   signal pgrp when data ready

    CNT Number of processes that know this open file.

    MSG Number of messages outstanding for this file.

    DATA
        The location of the vnode table entry or socket structure for this file.

    OFFSET
        The file offset (see lseek(2)).

-s  Print information about swap space usage on all the swap areas compiled into the kernel. The first column is the device name of the partition. The next column is the total space available in the partition. The Used column indicates the total blocks used so far; the Available column indicates how much space is remaining on each partition. The Capacity reports the percentage of space used.

    If more than one partition is configured into the system, totals for all of the statistics will be reported in the final line of the report.

-t  Print table for terminals with these headings:

    RAW Number of characters in raw input queue.

    CAN Number of characters in canonicalized input queue.

    OUT Number of characters in putput queue.

    MODE
        See tty(4).

    ADDR
        Physical device address.

    DEL Number of delimiters (newlines) in canonicalized input queue.

    COL Calculated column position of terminal.

    STATE
        Miscellaneous state variables encoded thus:

        T   delay timeout in progress

        W   waiting for open to complete

        O   open

        F   outq has been flushed during DMA

        C   carrier is on

        c   connection open

        B   busy doing output

        A   process is waiting for space in output queue

        a   process is waiting for output to complete

        X   open for exclusive use

        S   output stopped (ixon flow control)

        m   output stopped (carrier flow control)

        o   output stopped (CTS flow control)

        d   output stopped (DSR flow control)

        K   input stopped

        Y   send SIGIO for input events

        D   state for lowercase ‘\’ work

        E   within a ‘\.../’ for PRTRUB

        L   next character is literal

        P   retyping suspended input (PENDIN)

        N   counting tab width, ignore FLUSHO

        l   block mode input routine in use

        s   i/o being snooped

        Z   connection lost

    SESS
        Kernel address of the session structure.

    PGID
        Process group for which this is controlling terminal.

    DISC
        Line discipline; ‘term’ for TTYDISC or ‘ntty’ for NTTYDISC or ‘tab’ for TABLDISC or ‘slip’ for SLIPDISC or ‘ppp’ for PPPDISC.

-v  Print the active vnodes. Each group of vnodes corresponding to a particular filesystem is preceded by a two line header. The first line consists of the following:

    *** MOUNT fstype from on on fsflags

    where fstype is one of ufs, nfs, mfs, or pc; from is the filesystem is mounted from; on is the directory the filesystem is mounted on; and fsflags is a list of optional flags applied to the mount (see mount(8)). the first part of which are fixed, and the second part are filesystem type specific. The headers common to all vnodes are:

    ADDR
        Location of this vnode.

    TYP File type.

    VFLAG

        A list of letters representing vnode flags:

        R   - VROOT

        T   - VTEXT

        L   - VXLOCK

        W   - VXWANT

        E   - VEXLOCK

        S   - VSHLOCK

        T   - VLWAIT

        A   - VALIASED

        B   - VBWAIT

    USE The number of references to this vnode.

    HOLD
        The number of I/O buffers held by this vnode.

    FILEID
        The vnode fileid. In the case of ufs this is the inode number.

    IFLAG
        Miscellaneous filesystem specific state variables encoded thus:

        For ufs:

            L   locked

            U   update time (fs(5)) must be corrected

            A   access time must be corrected

            W   wanted by another process (L flag is on)

            C   changed time must be corrected

            S   shared lock applied

            E   exclusive lock applied

            Z   someone waiting for a lock

            M   contains modifications

            R   has a rename in progress

        For nfs:

            W   waiting for I/O buffer flush to complete

            P   I/O buffers being flushed

            M   locally modified data exists

            E   an earlier write failed

            X   non-cacheable lease (nqnfs)

            O   write lease (nqnfs)

            G   lease was evicted (nqnfs)

    SIZ/RDEV
        Number of bytes in an ordinary file, or major and minor device of special file.

FILES
/kernel
    namelist
/dev/kmem
    default source of tables

SEE ALSO
iostat(1), ps(1), systat(1), vmstat(1), stat(2), fs(5),

BUGS
Does not understand NFS swap servers.

HISTORY
The pstat command appeared in 4.0BSD.